     *=====================================================================*                 RADDAT
     *  WSDL2RPG: WDSL Type                                                *                 RADDAT
     *=====================================================================*                 RADDAT
     *  Author  :  Thomas Raddatz                                          *                 RADDAT
     *  Date    :  06.11.2007                                              *                 RADDAT
     *  E-mail  :  thomas.raddatz@Tools400.de                              *                 RADDAT
     *  Homepage:  www.tools400.de                                         *                 RADDAT
     *=====================================================================*                 RADDAT
     *                                                                     *                 RADDAT
     *  This software is free software, you can redistribute it and/or     *                 RADDAT
     *  modify it under the terms of the GNU General Public License (GPL)  *                 RADDAT
     *  as published by the Free Software Foundation.                      *                 RADDAT
     *                                                                     *                 RADDAT
     *  See GNU General Public License for details.                        *                 RADDAT
     *          http://www.opensource.org                                  *                 RADDAT
     *          http://www.opensource.org/licenses/gpl-license.html        *                 RADDAT
     *                                                                     *                 RADDAT
     *=====================================================================*                 RADDAT
     *  History:                                                           *                 RADDAT
     *                                                                     *                 RADDAT
     *  Datum       Name          nderung                                 *                 RADDAT
     *  ----------  ------------  ---------------------------------------  *                 RADDAT
     *  18.03.2008  Th.Raddatz    Changed the repository to distinguish    *                 RADDAT
     *                            between 'elements' and 'types'.          *                 RADDAT
     *                            See: PMR004 (GetWeatherBy*)              *                 RADDAT
     *                                                                     *                 RADDAT
     *  31.10.2008  Th.Raddatz    Replaced import 'g_hTypes' by procedure  *                 RADDAT
     *                            call to Controller_getGlobalTypesList(). *                 RADDAT
     *                                                                     *                 RADDAT
     *  01.11.2008  Th.Raddatz    Added 'isChoice' attribute to            *                 RADDAT
     *                            'subTypesList'.                          *                 RADDAT
     *                                                                     *                 RADDAT
     *  08.01.2009  Th.Raddatz    Changed TypeDef_produceName() to only    *                 RADDAT
     *                            compare the local name part when         *                 RADDAT
     *                            testing for duplicate names.             *                 RADDAT
     *                                                                     *                 RADDAT
     *  29.01.2009  Th.Raddatz    Changed Type_isPrimitive() to also check *                 RADDAT
     *                            the type for the SOAP encoding schema    *                 RADDAT
     *                            in order to fix the problem that         *                 RADDAT
     *                            primitive types were not correctly       *                 RADDAT
     *                            recognized if they belong to the         *                 RADDAT
     *                            SOAP encoding schema.                    *                 RADDAT
     *                                                                     *                 RADDAT
     *  17.04.2009  Th.Raddatz    Added procedures:                        *                 RADDAT
     *                               TypeDef_setQualified()                *                 RADDAT
     *                               TypeDef_isQualified()                 *                 RADDAT
     *                                                                     *                 RADDAT
     *  24.04.2009  Th.Raddatz    Added procedures:                        *                 RADDAT
     *                               TypeDef_hasChildren()                 *                 RADDAT
     *                                                                     *                 RADDAT
     *  25.05.2009  Th.Raddatz    Changed TypeDef_resolveReference() to    *                 RADDAT
     *                            handle references to xml schema data     *                 RADDAT
     *                            types. See sample provided by Ty Davis.  *                 RADDAT
     *                                                                     *                 RADDAT
     *  27.05.2009  Th.Raddatz    Changed TypeDef_getRefTypeKey() to use   *                 RADDAT
     *                            qType instead of qName to produce the    *                 RADDAT
     *                            key if the reference to the referenced   *                 RADDAT
     *                            type has been resolved.                  *                 RADDAT
     *                                                                     *                 RADDAT
     *  27.05.2009  Th.Raddatz    Changed TypeDef_resolveReference() to    *                 RADDAT
     *                            change the name of a given array value   *                 RADDAT
     *                            'item' or 'value' as done in             *                 RADDAT
     *                            WSDL2R59.produceXmlArray() for array     *                 RADDAT
     *                            values that do not reference another     *                 RADDAT
     *                            element.                                 *                 RADDAT
     *                                                                     *                 RADDAT
     *  11.06.2009  Th.Raddatz    Now calling XmlArray_convertToArray()    *                 RADDAT
     *                            to change an existing type to array.     *                 RADDAT
     *                                                                     *                 RADDAT
     *  12.06.2009  Th.Raddatz    Changed TypeDef_isPrimitive() to return  *                 RADDAT
     *                            cFalse for arrays.                       *                 RADDAT
     *                            Changed TypeDef_isPrimitive() to         *                 RADDAT
     *                            explicitly check for XML schema types.   *                 RADDAT
     *                            (Using their names instead of checking   *                 RADDAT
     *                            the namespace value)                     *                 RADDAT
     *                            Removed assert() that disabled XML array *                 RADDAT
     *                            types in TypeDef_getReferencedType().    *                 RADDAT
     *                            Always setting 'type.dim' to 0. Now      *                 RADDAT
     *                            'type.dim' is set for arrays in          *                 RADDAT
     *                            RpgArray_new().                          *                 RADDAT
     *                            Now 'type.arrayType' is set in           *                 RADDAT
     *                            XmlArray_new() and RpgArray_new().       *                 RADDAT
     *                                                                     *                 RADDAT
     *=====================================================================*                 RADDAT
     *   >>PRE-COMPILER<<                                                  *                 RADDAT
     *                                                                     *                 RADDAT
     *     >>CRTCMD<<  CRTRPGMOD   MODULE(&LI/&OB) +                       *                 RADDAT
     *                             SRCFILE(&SL/&SF) +                      *                 RADDAT
     *                             SRCMBR(&SM);                            *                 RADDAT
     *                                                                     *                 RADDAT
     *     >>COMPILE<<                                                     *                 RADDAT
     *       >>PARM<< TRUNCNBR(*NO);                                       *                 RADDAT
     *       >>PARM<< DBGVIEW(*LIST);                                      *                 RADDAT
     *       >>PARM<< TGTRLS(V5R3M0  );                                    *                 RADDAT
     *     >>END-COMPILE<<                                                 *                 RADDAT
     *                                                                     *                 RADDAT
     *     >>EXECUTE<<                                                     *                 RADDAT
     *                                                                     *                 RADDAT
     *   >>END-PRE-COMPILER<<                                              *                 RADDAT
     *=====================================================================*                 RADDAT
 CPY H NOMAIN                                                                                 RADDAT
CPY  /COPY QWSDL2RPG,H_SPEC                                                                 RADDAT
     *=====================================================================*                 RADDAT
     *                                                                                       RADDAT
     * ------------------------------------                                                  RADDAT
     *  Constants                                                                            RADDAT
     * ------------------------------------                                                  RADDAT
     *                                                                                       RADDAT
     * ------------------------------------                                                  RADDAT
     *  Type Definitions                                                                     RADDAT
     * ------------------------------------                                                  RADDAT
CPY  /COPY QWSDL2RPG,TYPES                                                                  RADDAT
CPYR *COPY QWSDL2RPG,CLIB                         C Runtime Library                          RADDAT
     *                                                                                       RADDAT
     * ------------------------------------                                                  RADDAT
     *  Exported prototypes                                                                  RADDAT
     * ------------------------------------                                                  RADDAT
CPY  /COPY QWSDL2RPG,PWSDL2R50                                                              RADDAT
     *                                                                                       RADDAT
     * ------------------------------------                                                  RADDAT
     *  Imported prototypes                                                                  RADDAT
     * ------------------------------------                                                  RADDAT
CPY  /COPY QBASICS1,PBASICS1                     Tools/400 Runtime Library
CPY  /COPY QLOG4RPG,PLOG4RPG                     Log4rpg                                    RADDAT
     *                                                                                       RADDAT
CPY  /COPY QWSDL2RPG,PWSDL2R01                   WSDL2RPG: Main / Controller                RADDAT
CPY  /COPY QWSDL2RPG,PWSDL2R02                   WSDL2RPG: Namespaces                       RADDAT
CPY  /COPY QWSDL2RPG,PWSDL2R59                   WSDL2RPG: WSDL XmlArray                    RADDAT
CPY  /COPY QWSDL2RPG,PWSDL2R91                   WSDL2RPG: QName                            RADDAT
CPY  /COPY QWSDL2RPG,PWSDL2R92                   UnMarshaller/Marshaller Helper             RADDAT
CPY  /COPY QWSDL2RPG,PWSDL2R99                   WSDL2RPG: Common Helper Procedures         RADDAT
     *                                                                                       RADDAT
     * ------------------------------------                                                  RADDAT
     *  Internal prototypes                                                                  RADDAT
     * ------------------------------------                                                  RADDAT
     *                                                                                       RADDAT
     *  Initializes a type definition.                                                       RADDAT
     D initializeTypeDef...                                                                   RADDAT
     D                 PR                         likeds(wsdl_type_t )                        RADDAT
     D  i_name                             const  like(wsdl_name_t   )                        RADDAT
     D  i_type                             const  like(wsdl_name_t   )                        RADDAT
     *                                                                                       RADDAT
     *  Returns a RPG callback procedure base name for a given type.                         RADDAT
     D getProcName...                                                                         RADDAT
     D                 PR                         like(wsdl_name_t   )                        RADDAT
     D                                     extproc('getProcName')                             RADDAT
     D  i_type                             const  likeds(wsdl_type_t )                        RADDAT
     D  i_parent                           const  likeds(wsdl_type_t )                        RADDAT
     *                                                                                       RADDAT
     *  Initializes this module.                                                             RADDAT
     D initializeModule...                                                                    RADDAT
     D                 PR                                                                     RADDAT
     D                                     extproc('initializeModule')                        RADDAT
     *                                                                                       RADDAT
     * ------------------------------------                                                  RADDAT
     *  Global fields & constants                                                            RADDAT
     * ------------------------------------                                                  RADDAT
     D g_isInit        S               N   inz(cFalse)                                        RADDAT
     *                                                                                       RADDAT
     D g_hLogger       S                   like(LOG4RPG_hLogger_t)                            RADDAT
     D g_hArrayDim     S                   like(BasicMap_handle_t)   import                   RADDAT
     *                                                                                       RADDAT
     D g_depth         DS                  qualified                                          RADDAT
     D  delete                       10I 0 inz                                                RADDAT
     *                                                                                       RADDAT
     D cTAB            C                   3                                                  RADDAT
     *                                                                                       RADDAT
     * ------------------------------------                                                  RADDAT
     *  Program Status Data Structure                                                        RADDAT
     * ------------------------------------                                                  RADDAT
      /DEFINE SDS_EXTENDED                                                                    RADDAT
CPY  /COPY QWSDL2RPG,SDS                                                                    RADDAT
      /UNDEFINE SDS_EXTENDED                                                                  RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Returns a new 'element' type definition.                                             RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_newElement...                                                                  RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_newElement...                                                                  RADDAT
     D                 PI                         likeds(wsdl_type_t )                        RADDAT
     D  i_name                             const  like(wsdl_name_t   )                        RADDAT
     D  i_type                             const  like(wsdl_name_t   )                        RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D type            DS                  likeds(wsdl_type_t ) inz                           RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
         type = initializeTypeDef(i_name: i_type);                                          //RADDAT
                                                                                            //RADDAT
         type.defType = cTYPE_DEFTYPE_ELEMENT;                                              //RADDAT
                                                                                            //RADDAT
         Logger_debug(g_hLogger:
                      'Created (' + type.defType + '): ' +
                      TypeDef_toString(type));                                              //RADDAT
                                                                                            //RADDAT
         return type;                                                                       //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_newElement...                                                                  RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Returns a new 'type' type definition.                                                RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_newType...                                                                     RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_newType...                                                                     RADDAT
     D                 PI                         likeds(wsdl_type_t )                        RADDAT
     D  i_name                             const  like(wsdl_name_t   )                        RADDAT
     D  i_type                             const  like(wsdl_name_t   )                        RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D type            DS                  likeds(wsdl_type_t ) inz                           RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
         type = initializeTypeDef(i_name: i_type);                                          //RADDAT
                                                                                            //RADDAT
         type.defType = cTYPE_DEFTYPE_TYPE;                                                 //RADDAT
                                                                                            //RADDAT
         Logger_debug(g_hLogger:
                      'Created (' + type.defType + '): ' +
                      TypeDef_toString(type));                                              //RADDAT
                                                                                            //RADDAT
         return type;                                                                       //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_newType...                                                                     RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Clones a given type.                                                                 RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_clone...                                                                       RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_clone...                                                                       RADDAT
     D                 PI                         likeds(wsdl_type_t )                        RADDAT
     D  i_type                             const  likeds(wsdl_type_t )                        RADDAT
     D  i_qName                            const  likeds(wsdl_qName_t)                        RADDAT
     D                                            options(*nopass)                            RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D clonedType      DS                  likeds(wsdl_type_t ) inz                           RADDAT
     *                                                                                       RADDAT
     *  Parameter positions                                                                  RADDAT
     D p_qName         C                   2                                                  RADDAT
     *                                                                                       RADDAT
     *  Fields for optional parameters                                                       RADDAT
     D qName           DS                  likeds(i_qName     ) inz                           RADDAT
     *                                                                                       RADDAT
     *  Helper fields                                                                        RADDAT
     D x               S             10I 0 inz                                                RADDAT
     D subType         DS                  likeds(wsdl_type_t ) inz                           RADDAT
     D clonedSubType   DS                  likeds(wsdl_type_t ) inz                           RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
         //Get optional parameter values ...                                               //RADDAT
         //... qName                                                                       //RADDAT
 B01     if (%parms() >= p_qName);                                                          //RADDAT
            qName = i_qName;                                                                //RADDAT
 X01     else;                                                                              //RADDAT
            qName = QName_null();                                                           //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         clonedType = i_type;                                                               //RADDAT
 B01     if (not QName_isNull(qName));                                                      //RADDAT
            clonedType.qName = qName;                                                       //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
 B01     if (TypeDef_isSequence(clonedType) and TypeDef_hasChildren(i_type));               //RADDAT
                                                                                            //RADDAT
            clonedType.subTypesList.hMap = BasicMap_new();                                  //RADDAT
                                                                                            //RADDAT
 B02        for x = 1 to BasicMap_getNumE(i_type.subTypesList.hMap);                        //RADDAT
               BasicMap_getValueByIndex(i_type.subTypesList.hMap: x
                                        : %addr(subType): %size(subType));                  //RADDAT
               clonedSubType = TypeDef_clone(subType);                                      //RADDAT
               TypeDef_addSubType(clonedType: clonedSubType);                               //RADDAT
 E02        endfor;                                                                         //RADDAT
                                                                                            //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         return clonedType;                                                                 //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_clone...                                                                       RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Returns the key of a given type.                                                     RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_getKey...                                                                      RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_getKey...                                                                      RADDAT
     D                 PI                         like(wsdl_mapKey_t )                        RADDAT
     D  i_type                             const  likeds(wsdl_type_t )                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
         return produceTypeDefKey(i_type.qName: i_type.defType);                            //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_getKey...                                                                      RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Returns the key of the referenced type.                                              RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_getRefTypeKey...                                                               RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_getRefTypeKey...                                                               RADDAT
     D                 PI                         like(wsdl_mapKey_t )                        RADDAT
     D  i_type                             const  likeds(wsdl_type_t )                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
 B01     if (TypeDef_referencesType(i_type));                                               //RADDAT
 B02        if (QName_getLName(TypeDef_getQType(i_type)) = cTYPE_REFERENCE);                //RADDAT
               return produceTypeDefKey(i_type.qName: cTYPE_DEFTYPE_ELEMENT);               //RADDAT
 X02        else;                                                                           //RADDAT
               return produceTypeDefKey(i_type.qType: cTYPE_DEFTYPE_ELEMENT);               //RADDAT
 E02        endif;                                                                          //RADDAT
 X01     else;                                                                              //RADDAT
            return produceTypeDefKey(i_type.qType: cTYPE_DEFTYPE_TYPE);                     //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_getRefTypeKey...                                                               RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Specifies, whether the type must be qualified or not.                                RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_setQualified...                                                                RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_setQualified...                                                                RADDAT
     D                 PI                                                                     RADDAT
     D  io_type                                   likeds(wsdl_type_t )                        RADDAT
     D  i_isQualified                  N   const                                              RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
         io_type.isQualified = i_isQualified;                                               //RADDAT
                                                                                            //RADDAT
         return;                                                                            //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_setQualified...                                                                RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Returns cTrue if the type must be qualified, else cFalse.                            RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_isQualified...                                                                 RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_isQualified...                                                                 RADDAT
     D                 PI              N                                                      RADDAT
     D  i_type                             const  likeds(wsdl_type_t )                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
         return i_type.isQualified;                                                         //RADDAT
                                                                                            //RADDAT
         return;                                                                            //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_isQualified...                                                                 RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Sets the array dimension of a given type.                                            RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_setDim...                                                                      RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_setDim...                                                                      RADDAT
     D                 PI                                                                     RADDAT
     D  io_type                                   likeds(wsdl_type_t )                        RADDAT
     D  i_dim                              const  like(wsdl_dim_t    )                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
         io_type.dim = i_dim;                                                               //RADDAT
                                                                                            //RADDAT
         return;                                                                            //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_setDim...                                                                      RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Returns the array dimension of a given type.                                         RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_getDim...                                                                      RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_getDim...                                                                      RADDAT
     D                 PI                         like(wsdl_dim_t    )                        RADDAT
     D  i_type                             const  likeds(wsdl_type_t )                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
         p_assert(TypeDef_isArrayValue(i_type)
                  : 'Illegal call to: ' + f_this());                                        //RADDAT
                                                                                            //RADDAT
 B01     if (i_type.dim = -1);   //Unbounded                                               //RADDAT
            return Controller_getDefaultArrayDim();                                         //RADDAT
 X01     else;                                                                              //RADDAT
            return i_type.dim;                                                              //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         return;                                                                            //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_getDim...                                                                      RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Returns the constant that defines the dimension of a given array.                    RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_getDimConstant...                                                              RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_getDimConstant...                                                              RADDAT
     D                 PI            32A          varying                                     RADDAT
     D  i_type                             const  likeds(wsdl_type_t )                        RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D dimConstant     S             32A   varying inz                                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
         p_assert(TypeDef_isArrayValue(i_type)
                  : 'Illegal call to: ' + f_this());                                        //RADDAT
                                                                                            //RADDAT
         dimConstant = 'DIM_' + TypeDef_getArrayID(i_type);                                 //RADDAT
                                                                                            //RADDAT
         return dimConstant;                                                                //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_getDimConstant...                                                              RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Returns the array ID of a given type.                                                RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_getArrayID...                                                                  RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_getArrayID...                                                                  RADDAT
     D                 PI            32A          varying                                     RADDAT
     D  i_type                             const  likeds(wsdl_type_t )                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         p_assert(TypeDef_isArrayValue(i_type)
                  : 'Illegal call to: ' + f_this());                                        //RADDAT
                                                                                            //RADDAT
         p_assert(i_type.arrayID > 0
                  : 'Array ID must be greater than 0');                                     //RADDAT
                                                                                            //RADDAT
         return 'A' + %char(i_type.arrayID);                                                //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_getArrayID...                                                                  RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Flags the typ as a the index of an array.                                            RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_setIsArrayIndex...                                                             RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_setIsArrayIndex...                                                             RADDAT
     D                 PI                                                                     RADDAT
     D  io_type                                   likeds(wsdl_type_t )                        RADDAT
     D  i_isIndex                      N   const                                              RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
         Logger_debug(g_hLogger:
                      'Set ''is array index'' flag of type ' +
                       TypeDef_toString(io_type) +
                      ' to: ' + i_isIndex);                                                 //RADDAT
                                                                                            //RADDAT
 B01     if (i_isIndex);                                                                    //RADDAT
            io_type.arrayType = cARRAY_INDEX;                                               //RADDAT
 X01     else;                                                                              //RADDAT
            io_type.arrayType = cARRAY_NONE;                                                //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         return;                                                                            //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_setIsArrayIndex...                                                             RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Returns cTrue, if the type is the index field of an array.                           RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_isArrayIndex...                                                                RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_isArrayIndex...                                                                RADDAT
     D                 PI              N                                                      RADDAT
     D  i_type                             const  likeds(wsdl_type_t )                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
 B01     if (i_type.arrayType = cARRAY_INDEX);                                              //RADDAT
            return cTrue;                                                                   //RADDAT
 X01     else;                                                                              //RADDAT
            return cFalse;                                                                  //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_isArrayIndex...                                                                RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Flags the typ as a the value of an array.                                            RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_setIsArrayValue...                                                             RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_setIsArrayValue...                                                             RADDAT
     D                 PI                                                                     RADDAT
     D  io_type                                   likeds(wsdl_type_t )                        RADDAT
     D  i_isValue                      N   const                                              RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
         Logger_debug(g_hLogger:
                      'Set ''is array value'' flag of type ' +
                       TypeDef_toString(io_type) +
                      ' to: ' + i_isValue);                                                 //RADDAT
                                                                                            //RADDAT
 B01     if (i_isValue);                                                                    //RADDAT
            io_type.arrayType = cARRAY_VALUE;                                               //RADDAT
 X01     else;                                                                              //RADDAT
            io_type.arrayType = cARRAY_NONE;                                                //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         return;                                                                            //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_setIsArrayValue...                                                             RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Returns cTrue, if the type is the value field of an array.                           RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_isArrayValue...                                                                RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_isArrayValue...                                                                RADDAT
     D                 PI              N                                                      RADDAT
     D  i_type                             const  likeds(wsdl_type_t )                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
 B01     if (i_type.arrayType = cARRAY_VALUE);                                              //RADDAT
            return cTrue;                                                                   //RADDAT
 X01     else;                                                                              //RADDAT
            return cFalse;                                                                  //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_isArrayValue...                                                                RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Type helper:                                                                         RADDAT
     *  Returns the qualified name of a given type.                                          RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_getQName...                                                                    RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_getQName...                                                                    RADDAT
     D                 PI                         likeds(wsdl_qName_t)                        RADDAT
     D  i_type                             const  likeds(wsdl_type_t )                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
         return i_type.qName;                                                               //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_getQName...                                                                    RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Type helper:                                                                         RADDAT
     *  Returns the qualified type of a given type.                                          RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_getQType...                                                                    RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_getQType...                                                                    RADDAT
     D                 PI                         likeds(wsdl_qName_t)                        RADDAT
     D  i_type                             const  likeds(wsdl_type_t )                        RADDAT
     *                                                                                       RADDAT
     *  Local fields                                                                         RADDAT
     D refType         DS                  likeds(wsdl_type_t ) inz                           RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
         refType = i_type;                                                                  //RADDAT
                                                                                            //RADDAT
         return refType.qType;                                                              //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_getQType...                                                                    RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Sets the qualified type of a given type.                                             RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_setQType...                                                                    RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_setQType...                                                                    RADDAT
     D                 PI                                                                     RADDAT
     D  io_type                                   likeds(wsdl_type_t )                        RADDAT
     D  i_qType                            const  likeds(wsdl_qName_t)                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
 B01     if (QName_getNSValue(i_qType) = cNS_WSDL_SOAP_ENCODING and
             QName_getLName(i_qType) = cSOAP_ARRAY);                                        //RADDAT
            XmlArray_convertToArray(io_type);                                               //RADDAT
            return;                                                                         //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         io_type.qType = i_qType;                                                           //RADDAT
                                                                                            //RADDAT
         return;                                                                            //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_setQType...                                                                    RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Type helper:                                                                         RADDAT
     *  Returns cTrue if a given type is part of a 'choice' group.                           RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_isChoice...                                                                    RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_isChoice...                                                                    RADDAT
     D                 PI              N                                                      RADDAT
     D  i_type                             const  likeds(wsdl_type_t     )                    RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
 B01     if (i_type.isChoice);                                                              //RADDAT
            return cTrue;                                                                   //RADDAT
 X01     else;                                                                              //RADDAT
            return cFalse;                                                                  //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_isChoice...                                                                    RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Type helper:                                                                         RADDAT
     *  Flags a given type as part of a choice group.                                        RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_setIsChoice...                                                                 RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_setIsChoice...                                                                 RADDAT
     D                 PI                                                                     RADDAT
     D  io_type                                   likeds(wsdl_type_t     )                    RADDAT
     D  i_isChoice                     N   const                                              RADDAT
     *                                                                                       RADDAT
     *  Local fields                                                                         RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
 B01     if (i_isChoice);                                                                   //RADDAT
            Logger_debug(g_hLogger:
                         'Flagged ' + TypeDef_toString(io_type) +
                         ' as part of a <choice> group.');                                  //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         io_type.isChoice = i_isChoice;                                                     //RADDAT
                                                                                            //RADDAT
         return;                                                                            //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_setIsChoice...                                                                 RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Type helper:                                                                         RADDAT
     *  Returns cTrue if a given type is 'in use'.                                           RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_isUsed...                                                                      RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_isUsed...                                                                      RADDAT
     D                 PI              N                                                      RADDAT
     D  i_type                             const  likeds(wsdl_type_t     )                    RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
 B01     if (i_type.isUsed);                                                                //RADDAT
            return cTrue;                                                                   //RADDAT
 X01     else;                                                                              //RADDAT
            return cFalse;                                                                  //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_isUsed...                                                                      RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Type helper:                                                                         RADDAT
     *  Flags a given type as 'in use'.                                                      RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_setIsUsed...                                                                   RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_setIsUsed...                                                                   RADDAT
     D                 PI                                                                     RADDAT
     D  io_type                                   likeds(wsdl_type_t     )                    RADDAT
     D  i_isUsed                       N   const                                              RADDAT
     *                                                                                       RADDAT
     *  Local fields                                                                         RADDAT
     D x               S             10I 0 inz                                                RADDAT
     D numSubTypes     S             10I 0 inz                                                RADDAT
     *                                                                                       RADDAT
     D userType        DS                  likeds(wsdl_type_t )                               RADDAT
     D                                     based(pUserType)                                   RADDAT
     D subType         DS                  likeds(wsdl_type_t )                               RADDAT
     D                                     based(pSubType)                                    RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
         //Return to caller, if the type is already flagged as 'is used'                   //RADDAT
         //to avoid that an array is registered twice.                                     //RADDAT
 B01     if (io_type.isUsed);                                                               //RADDAT
            return;                                                                         //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         io_type.isUsed = i_isUsed;                                                         //RADDAT
                                                                                            //RADDAT
 B01     if (TypeDef_isXmlArray(io_type));                                                  //RADDAT
            XmlArray_register(io_type);                                                     //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         Logger_debug(g_hLogger:
                      'Set ''in use'' flag of type ' +
                       TypeDef_toString(io_type) +
                      ' (' + io_type.defType + ') to: ' + i_isUsed);                        //RADDAT
                                                                                            //RADDAT
         //Done, if it is a primitive type                                                 //RADDAT
 B01     if (TypeDef_isPrimitive(io_type));                                                 //RADDAT
            return;                                                                         //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         //Done, if it is not (yet) defined                                                //RADDAT
 B01     if (not TypeDef_isDefined(io_type));                                               //RADDAT
            return;                                                                         //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         //Flag also the sub types, if it is a sequence                                    //RADDAT
 B01     if (TypeDef_isSequence(io_type) and TypeDef_hasChildren(io_type));                 //RADDAT
            numSubTypes = BasicMap_getNumE(io_type.subTypesList.hMap);                      //RADDAT
 B02        if (numSubTypes = 0);                                                           //RADDAT
               Logger_error(g_hLogger:
                            'Sub-types of type <' +
                             TypeDef_toString(io_type) + '> not found.');                   //RADDAT
 E02        endif;                                                                          //RADDAT
 B02        for x = 1 to numSubTypes;                                                       //RADDAT
               pSubType =
                  BasicMap_getValueByIndex(io_type.subTypesList.hMap: x);                   //RADDAT
               TypeDef_setIsUsed(subType: i_isUsed);                                        //RADDAT
 E02        endfor;                                                                         //RADDAT
            return;                                                                         //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         //Flag the user defined type that is referenced by this type                      //RADDAT
 B01     if (TypeDef_isUserDefined(io_type));                                               //RADDAT
            pUserType = TypeDef_getReferencedType(io_type);                                 //RADDAT
 B02        if (pUserType <> *NULL);                                                        //RADDAT
               TypeDef_setIsUsed(userType: cTrue);                                          //RADDAT
 X02        else;                                                                           //RADDAT
               Logger_error(g_hLogger:
                            'Referenced user defined type of <' +
                             TypeDef_toString(io_type) + '> not found.');                   //RADDAT
 E02        endif;                                                                          //RADDAT
            return;                                                                         //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         return;                                                                            //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_setIsUsed...                                                                   RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Returns cTrue if the type is a primitive schema type.                                RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_isPrimitive...                                                                 RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_isPrimitive...                                                                 RADDAT
     D                 PI              N                                                      RADDAT
     D  i_type                             const  likeds(wsdl_type_t  )                       RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D isPrimitiveType...                                                                     RADDAT
     D                 S               N   inz(cFalse)                                        RADDAT
     D lName           S                   like(wsdl_name_t ) inz                             RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
 B01     if (not TypeDef_isDefined(i_type));                                                //RADDAT
            isPrimitiveType = cFalse;                                                       //RADDAT
            return isPrimitiveType;                                                         //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
 B01     if (TypeDef_isArray(i_type));                                                      //RADDAT
            isPrimitiveType = cFalse;                                                       //RADDAT
            return isPrimitiveType;                                                         //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
 B01     if (Namespaces_isSchemaNS(QName_getNSValue(i_type.qType)) or
 B01         Namespaces_isSOAPEncodingNS(QName_getNSValue(i_type.qType)));                  //RADDAT
            lName = f_lcase(QName_getLName(i_type.qType));                                  //RADDAT
 B02        if (lName = f_lcase('ENTITIES') or                 //XSD String Data Types
                lName = f_lcase('ENTITY') or
                lName = f_lcase('ID') or
                lName = f_lcase('IDREF') or
                lName = f_lcase('IDREFS') or
                lname = f_lcase('language') or
                lname = f_lcase('Name') or
                lname = f_lcase('NCName') or
                lname = f_lcase('NMTOKEN') or
                lname = f_lcase('NMTOKENS') or
                lname = f_lcase('normalizedString') or
                lname = f_lcase('QName') or
                lname = f_lcase('string') or
                lname = f_lcase('token') or
                lname = f_lcase('date') or                     //XSD Date and Time Data Types
                lname = f_lcase('dateTime') or
                lname = f_lcase('duration') or
                lname = f_lcase('gDay') or
                lname = f_lcase('gMonth') or
                lname = f_lcase('gMonthDay') or
                lname = f_lcase('gYear') or
                lname = f_lcase('gYearMonth') or
                lname = f_lcase('time') or
                lname = f_lcase('byte') or                     //Decimal Data Type
                lname = f_lcase('decimal') or
                lname = f_lcase('int') or
                lname = f_lcase('integer') or
                lname = f_lcase('long') or
                lname = f_lcase('negativeInteger') or
                lname = f_lcase('nonNegativeInteger') or
                lname = f_lcase('nonPositiveInteger') or
                lname = f_lcase('positiveInteger') or
                lname = f_lcase('short') or
                lname = f_lcase('unsignedLong') or
                lname = f_lcase('unsignedInt') or
                lname = f_lcase('unsignedShort') or
                lname = f_lcase('unsignedByte') or
                lname = f_lcase('anyURI') or                   //XSD Miscellaneous Data Types
                lname = f_lcase('anyType') or
                lname = f_lcase('base64Binary') or
                lname = f_lcase('boolean') or
                lname = f_lcase('double') or
                lname = f_lcase('float') or
                lname = f_lcase('hexBinary') or
                lname = f_lcase('NOTATION') or
                lname = f_lcase('QName') or
                lname = f_lcase(cXSD_ANY) or                   //WSDL2RPG special types
                lname = f_lcase(cXSD_SCHEMA));                                              //RADDAT
               isPrimitiveType = cTrue;                                                     //RADDAT
 X02        else;                                                                           //RADDAT
               isPrimitiveType = cFalse;                                                    //RADDAT
 E02        endif;                                                                          //RADDAT
 X01     else;                                                                              //RADDAT
            isPrimitiveType = cFalse;                                                       //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         return isPrimitiveType;                                                            //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_isPrimitive...                                                                 RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Flags a given type as <sequence>.                                                    RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_setIsSequence...                                                               RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_setIsSequence...                                                               RADDAT
     D                 PI                                                                     RADDAT
     D  io_type                                   likeds(wsdl_type_t  )                       RADDAT
     D  i_isSequence                   N   const                                              RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
         Logger_debug(g_hLogger:
                      'Set ''is sequence'' flag of type ' +
                       TypeDef_toString(io_type) +
                      ' to: ' + i_isSequence);                                              //RADDAT
                                                                                            //RADDAT
         io_type.isSequence = i_isSequence;                                                 //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_setIsSequence...                                                               RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Returns cTrue if the type is a <sequence>.                                           RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_isSequence...                                                                  RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_isSequence...                                                                  RADDAT
     D                 PI              N                                                      RADDAT
     D  i_type                             const  likeds(wsdl_type_t  )                       RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
 B01     if (not TypeDef_isDefined(i_type));                                                //RADDAT
            return cFalse;                                                                  //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         return i_type.isSequence;                                                          //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_isSequence...                                                                  RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Returns cTrue if the type is a 'user-defined' type.                                  RADDAT
     *=====================================================================*                 RADDAT
     *  A type is a 'user-defined' type, if it is not a <sequence> and                       RADDAT
     *  not a 'primitive' type.                                                              RADDAT
     *  E.g.:   <element name="getStructureReturn" type="impl:Structure"/>                   RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_isUserDefined...                                                               RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_isUserDefined...                                                               RADDAT
     D                 PI              N                                                      RADDAT
     D  i_type                             const  likeds(wsdl_type_t  )                       RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
 B01     if (not TypeDef_isDefined(i_type));                                                //RADDAT
            return cFalse;                                                                  //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         return (not TypeDef_isSequence(i_type) and
                 not TypeDef_isPrimitive(i_type));                                          //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_isUserDefined...                                                               RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Returns cTrue if a gven type has child elements.                                     RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_hasChildren...                                                                 RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_hasChildren...                                                                 RADDAT
     D                 PI              N                                                      RADDAT
     D  i_type                             const  likeds(wsdl_type_t  )                       RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
 B01     if (not TypeDef_isSequence(i_type));                                               //RADDAT
            return cFalse;                                                                  //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
 B01     if (BasicMap_isNull(i_type.subTypesList.hMap));                                    //RADDAT
            return cFalse;                                                                  //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
 B01     if (BasicMap_getNumE(i_type.subTypesList.hMap) = 0);                               //RADDAT
            return cFalse;                                                                  //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         return cTrue;                                                                      //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_hasChildren...                                                                 RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Returns cTrue if the type is uses the 'ref' attribute to reference                   RADDAT
     *  another type.                                                                        RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_referencesType...                                                              RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_referencesType...                                                              RADDAT
     D                 PI              N                                                      RADDAT
     D  i_type                             const  likeds(wsdl_type_t  )                       RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
         return i_type.referencesType;                                                      //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_referencesType...                                                              RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Resolves the reference to the type that is referenced by                             RADDAT
     *  a given type.                                                                        RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_resolveReference...                                                            RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_resolveReference...                                                            RADDAT
     D                 PI                                                                     RADDAT
     D  io_type                                   likeds(wsdl_type_t  )                       RADDAT
     D  i_hTypes                           const  like(BasicMap_handle_t )                    RADDAT
     *                                                                                       RADDAT
     *  Helper fields                                                                        RADDAT
     D tmpType         DS                  likeds(wsdl_type_t ) inz                           RADDAT
     D qName           DS                  likeds(wsdl_qName_t) inz                           RADDAT
     D refType         DS                  likeds(wsdl_type_t ) inz                           RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
         p_assert(TypeDef_referencesType(io_type)
                  : 'Illegal call to: ' + f_this());                                        //RADDAT
                                                                                            //RADDAT
 B01     if (io_type.qType.lName <> cTYPE_REFERENCE);                                       //RADDAT
            return;                                                                         //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
 B01     if (Namespaces_isSchemaNS(QName_getNSValue(io_type.qName)));                       //RADDAT
 B02        select;                                                                         //RADDAT
            when (QName_getLName(io_type.qName) = 'schema');                                //RADDAT
               qName =
                  QName_new(Namespaces_getSchemaPrefix() + ':' + cXSD_SCHEMA);              //RADDAT
 E02        endsl;                                                                          //RADDAT
            io_type.qType = qName;                                                          //RADDAT
            return;                                                                         //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         TypeDef_getReferencedType(io_type: refType);                                       //RADDAT
                                                                                            //RADDAT
         io_type.qType = refType.qName;                                                     //RADDAT
 B01     if (refType.defType = cTYPE_DEFTYPE_ELEMENT);                                      //RADDAT
            io_type.referencesType = '1';                                                   //RADDAT
 X01     else;                                                                              //RADDAT
            io_type.referencesType = '0';                                                   //RADDAT
 E01     endif;                                                                             //RADDAT
         tmpType = io_type;                                                                 //RADDAT
                                                                                            //RADDAT
 B01     if (TypeDef_isArrayValue(io_type));                                                //RADDAT
            BasicMap_remove(i_hTypes: TypeDef_getKey(io_type));                             //RADDAT
 B02        if (tmpType.qName.lName <> cGENERATOR_RPG_ARRAY_VALUE_NAME_1);                  //RADDAT
               tmpType.qName.lName = cGENERATOR_RPG_ARRAY_VALUE_NAME_1;                     //RADDAT
 X02        else;                                                                           //RADDAT
               tmpType.qName.lName = cGENERATOR_RPG_ARRAY_VALUE_NAME_2;                     //RADDAT
 E02        endif;                                                                          //RADDAT
            BasicMap_put(i_hTypes
                         : TypeDef_getKey(tmpType)
                         : %addr(tmpType)
                         : %size(tmpType));                                                 //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         Logger_debug(g_hLogger:
                      'Resolved reference of type ' +
                       TypeDef_toString(tmpType) +
                      ' to: ' + TypeDef_toString(refType));                                 //RADDAT
                                                                                            //RADDAT
         return;                                                                            //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_resolveReference...                                                            RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Type helper:                                                                         RADDAT
     *  Returns cTrue if a is defined. A type is considered to be defined,                   RADDAT
     *  if it has a name and a type or sub types.                                            RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_isDefined...                                                                   RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_isDefined...                                                                   RADDAT
     D                 PI              N                                                      RADDAT
     D  i_type                             const  likeds(wsdl_type_t )                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
 B01     if (TypeDef_isNull(i_type));                                                       //RADDAT
            return cFalse;                                                                  //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
 B01     if (QName_isNull(i_type.qName));                                                   //RADDAT
            return cFalse;                                                                  //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
 B01     if (QName_isNull(i_type.qType) and not i_type.isSequence);                         //RADDAT
            return cFalse;                                                                  //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         return cTrue;                                                                      //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_isDefined...                                                                   RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Returns cTrue if the type is an array, else cFalse.                                  RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_isArray...                                                                     RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_isArray...                                                                     RADDAT
     D                 PI              N                                                      RADDAT
     D  i_type                             const  likeds(wsdl_type_t )                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
 B01     select;                                                                            //RADDAT
         when (i_type.arrayType = cARRAY_XML);   //After the actual WSDL type was          //RADDAT
            return cTrue;                        //converted to an RPG array               //RADDAT
         when (i_type.arrayType = cARRAY_RPG);   //The RPG array of a WSDL array           //RADDAT
            return cTrue;                                                                   //RADDAT
 X01     other;                                                                             //RADDAT
            return cFalse;                                                                  //RADDAT
 E01     endsl;                                                                             //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_isArray...                                                                     RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Returns cTrue if the type is an XML array, else cFalse.                              RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_isXmlArray...                                                                  RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_isXmlArray...                                                                  RADDAT
     D                 PI              N                                                      RADDAT
     D  i_type                             const  likeds(wsdl_type_t )                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
 B01     if (i_type.arrayType = cARRAY_XML);                                                //RADDAT
            return cTrue;                                                                   //RADDAT
 X01     else;                                                                              //RADDAT
            return cFalse;                                                                  //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_isXmlArray...                                                                  RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Returns cTrue if the type is a RPG array, else cFalse.                               RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_isRpgArray...                                                                  RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_isRpgArray...                                                                  RADDAT
     D                 PI              N                                                      RADDAT
     D  i_type                             const  likeds(wsdl_type_t )                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
 B01     if (i_type.arrayType = cARRAY_RPG);                                                //RADDAT
            return cTrue;                                                                   //RADDAT
 X01     else;                                                                              //RADDAT
            return cFalse;                                                                  //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_isRpgArray...                                                                  RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Returns the referenced type if the given type is a user defined type.                RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_getReferencedType...                                                           RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_getReferencedType...                                                           RADDAT
     D                 PI              *                                                      RADDAT
     D  i_type                             const  likeds(wsdl_type_t  )                       RADDAT
     D  o_refType                                 likeds(wsdl_type_t  )                       RADDAT
     D                                            options(*nopass)                            RADDAT
     *                                                                                       RADDAT
     *  Parameter positions                                                                  RADDAT
     D p_refType       C                   2                                                  RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D pRefType        S               *   inz                                                RADDAT
     D refType         DS                  likeds(wsdl_type_t ) inz                           RADDAT
     *                                                                                       RADDAT
     *  Fields for optional parameter & return value                                         RADDAT
     D tmpType         DS                  likeds(wsdl_type_t )                               RADDAT
     D                                     based(pTmpType)                                    RADDAT
     *                                                                                       RADDAT
     *  Global types list
     D hGlobalTypes    S                   like(BasicMap_handle_t) inz
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
         pRefType = *NULL;                                                                  //RADDAT
         clear refType;                                                                     //RADDAT
                                                                                            //RADDAT
 B01     if (not TypeDef_isUserDefined(i_type));                                            //RADDAT
            p_assert(cFalse: 'Illegal call to: ' + f_this());                               //RADDAT
 E01     endif;                                                                             //RADDAT

         hGlobalTypes = Controller_getGlobalTypesList();
                                                                                            //RADDAT
         //Follow referenced types until you hit an array.                                 //RADDAT
         pTmpType = BasicMap_get(hGlobalTypes: TypeDef_getRefTypeKey(i_type));
         //p_assert(not TypeDef_isXmlArray(tmpType));                                      //RADDAT
 B01     dow (TypeDef_isUserDefined(tmpType) and
              not TypeDef_isArray(tmpType));                                                //RADDAT
              //not TypeDef_isRpgArray(tmpType));                                          //RADDAT
            pTmpType = BasicMap_get(hGlobalTypes
                                    : TypeDef_getRefTypeKey(tmpType));
            //p_assert(not TypeDef_isXmlArray(tmpType));                                   //RADDAT
 E01     enddo;                                                                             //RADDAT
                                                                                            //RADDAT
 B01     if (pTmpType = *NULL);                                                             //RADDAT
            Logger_error(g_hLogger:
                         'Referenced user defined type of <' +
                          TypeDef_toString(i_type) + '> not found.');                       //RADDAT
 X01     else;                                                                              //RADDAT
 B02        if (%parms() >= p_refType);                                                     //RADDAT
               o_refType = tmpType;                                                         //RADDAT
 E02        endif;                                                                          //RADDAT
            pRefType = pTmpType;                                                            //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         return pRefType;                                                                   //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_getReferencedType...                                                           RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Returns the final type if the given type is a user defined type.                     RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_getFinalType...                                                                RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_getFinalType...                                                                RADDAT
     D                 PI                         likeds(wsdl_type_t  )                       RADDAT
     D  i_type                             const  likeds(wsdl_type_t  )                       RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D finalType       DS                  likeds(wsdl_type_t ) inz                           RADDAT
     *                                                                                       RADDAT
     *  Fields for optional parameter & return value                                         RADDAT
     D refType         DS                  likeds(wsdl_type_t )                               RADDAT
     D                                     based(pRefType)                                    RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
         finalType = TypeDef_null();                                                        //RADDAT
                                                                                            //RADDAT
         //Get the referenced type                                                         //RADDAT
         pRefType = TypeDef_getReferencedType(i_type);                                      //RADDAT
                                                                                            //RADDAT
 B01     if (pRefType = *NULL);                                                             //RADDAT
            Logger_error(g_hLogger:
                         'Final type of user defined type <' +
                          TypeDef_toString(i_type) + '> not found.');                       //RADDAT
 X01     else;                                                                              //RADDAT
            finalType = refType;                                                            //RADDAT
            finalType.qName = i_type.qName;                                                 //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         return finalType;                                                                  //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_getFinalType...                                                                RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Returns a RPG start callback procedure name for a given type.                        RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_getStartProcName...                                                            RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_getStartProcName...                                                            RADDAT
     D                 PI                         like(wsdl_name_t   )                        RADDAT
     D  i_type                             const  likeds(wsdl_type_t )                        RADDAT
     D  i_parent                           const  likeds(wsdl_type_t )                        RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D name            S                   like(wsdl_name_t ) inz                             RADDAT
     *                                                                                       RADDAT
     *  Helper fields                                                                        RADDAT
     D qName           DS                  likeds(wsdl_qName_t) inz                           RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         name = getProcName(i_type: i_parent) + cGENERATOR_CALLBACK_START;                  //RADDAT
                                                                                            //RADDAT
 B01     if (TypeDef_isXmlArray(i_type));   //Hack! AXIS-2095                              //RADDAT
            name = name + '_of_' + getProcName(i_parent: TypeDef_null());                   //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         return name;                                                                       //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_getStartProcName...                                                            RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Returns a RPG start callback procedure name for a given type.                        RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_getEndProcName...                                                              RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_getEndProcName...                                                              RADDAT
     D                 PI                         like(wsdl_name_t   )                        RADDAT
     D  i_type                             const  likeds(wsdl_type_t )                        RADDAT
     D  i_parent                           const  likeds(wsdl_type_t )                        RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D name            S                   like(wsdl_name_t ) inz                             RADDAT
     *                                                                                       RADDAT
     *  Helper fields                                                                        RADDAT
     D qName           DS                  likeds(wsdl_qName_t) inz                           RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         name = getProcName(i_type: i_parent) + cGENERATOR_CALLBACK_END;                    //RADDAT
                                                                                            //RADDAT
 B01     if (TypeDef_isXmlArray(i_type));   //Hack! AXIS-2095                              //RADDAT
            name = name + '_of_' + getProcName(i_parent: TypeDef_null());                   //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         return name;                                                                       //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_getEndProcName...                                                              RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Adds a sub-type to a given type.                                                     RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_addSubType...                                                                  RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_addSubType...                                                                  RADDAT
     D                 PI                                                                     RADDAT
     D  io_type                                   likeds(wsdl_type_t )                        RADDAT
     D  i_subType                          const  likeds(wsdl_type_t )                        RADDAT
     *                                                                                       RADDAT
     *  Helper fields                                                                        RADDAT
     D subType         DS                  likeds(i_subType) inz                              RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
         p_assert(TypeDef_isSequence(io_type):
                  'Type must be a sequence type.');                                         //RADDAT
                                                                                            //RADDAT
 B01     if (BasicMap_isNull(io_type.subTypesList.hMap));                                   //RADDAT
            io_type.subTypesList.hMap = BasicMap_new();                                     //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         subType = i_subType;                                                               //RADDAT
                                                                                            //RADDAT
         BasicMap_put(io_type.subTypesList.hMap
                      : TypeDef_getKey(i_subType)
                      : %addr(subType)
                      : %size(subType));                                                    //RADDAT
                                                                                            //RADDAT
         Logger_debug(g_hLogger:
                      'Added type ' + TypeDef_toString(i_subType) +
                      ' to types list of type ' + TypeDef_toString(io_type));               //RADDAT
                                                                                            //RADDAT
         return;                                                                            //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_addSubType...                                                                  RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Returns a given type as 'string'.                                                    RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_toString...                                                                    RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_toString...                                                                    RADDAT
     D                 PI                         like(wsdl_name_t    )                       RADDAT
     D  i_type                             const  likeds(wsdl_type_t  )                       RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
         return QName_toString(i_type.qName);                                               //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_toString...                                                                    RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Returns a given type as a XML compliant string.                                      RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_toXml...                                                                       RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_toXml...                                                                       RADDAT
     D                 PI                         like(wsdl_name_t   )                        RADDAT
     D  i_type                             const  likeds(wsdl_type_t )                        RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D xmlString       S                   like(wsdl_name_t ) inz                             RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
         xmlString = QName_toXml(TypeDef_getQName(i_type));                                 //RADDAT
                                                                                            //RADDAT
         return xmlString;                                                                  //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_toXml...                                                                       RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Deletes a given type.                                                                RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_delete...                                                                      RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_delete...                                                                      RADDAT
     D                 PI                                                                     RADDAT
     D  io_type                                   likeds(wsdl_type_t )                        RADDAT
     *                                                                                       RADDAT
     *  Helper fields                                                                        RADDAT
     D qName           DS                  likeds(wsdl_qName_t ) inz                          RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
         g_depth.delete = g_depth.delete + 1;                                               //RADDAT
                                                                                            //RADDAT
         qName = TypeDef_getQName(io_type);                                                 //RADDAT
                                                                                            //RADDAT
         Logger_debug(g_hLogger:
                      f_space(cTAB * (g_depth.delete - 1)) +
                      'Deleting type: ' + QName_toString(qName) + ' ...');                  //RADDAT
                                                                                            //RADDAT
 B01     if (TypeDef_isSequence(io_type) and TypeDef_hasChildren(io_type));                 //RADDAT
            TypeDef_deleteSubTypes(io_type);                                                //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
 B01     if (not BasicMap_isNull(io_type.subTypesList.hMap));                               //RADDAT
            p_assert(BasicMap_getNumE(io_type.subTypesList.hMap) = 0:
                     'Map must not contain entries when +
                      type is going to be deleted');                                        //RADDAT
            BasicMap_delete(io_type.subTypesList.hMap);                                     //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         Logger_debug(g_hLogger:
                      f_space(cTAB * (g_depth.delete - 1)) +
                      'Deleted type: ' + QName_toString(qName));                            //RADDAT
                                                                                            //RADDAT
         g_depth.delete = g_depth.delete - 1;                                               //RADDAT
                                                                                            //RADDAT
         return;                                                                            //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_delete...                                                                      RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
   R *  *** private ***                                                                      RADDAT
     *  Removes all sub types from a given type.                                             RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_deleteSubTypes...                                                              RADDAT
    P                 B                                                                      RADDAT
     *                                                                                       RADDAT
     D TypeDef_deleteSubTypes...                                                              RADDAT
     D                 PI                                                                     RADDAT
     D  io_type                                   likeds(wsdl_type_t )                        RADDAT
     *                                                                                       RADDAT
     *  Helper fields                                                                        RADDAT
     D x               S             10I 0 inz                                                RADDAT
     *                                                                                       RADDAT
     D subType         DS                  likeds(wsdl_type_t )                               RADDAT
     D                                     based(pSubType)                                    RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
         p_assert(not BasicMap_isNull(io_type.subTypesList.hMap)
                  : 'Illegal call to: ' + f_this());                                        //RADDAT
                                                                                            //RADDAT
         x = BasicMap_getNumE(io_type.subTypesList.hMap);                                   //RADDAT
 B01     dow x > 0;                                                                         //RADDAT
            pSubType = BasicMap_getValueByIndex(io_type.subTypesList.hMap: 1);              //RADDAT
                                                                                            //RADDAT
            TypeDef_delete(subType);                                                        //RADDAT
                                                                                            //RADDAT
            BasicMap_remove(io_type.subTypesList.hMap
                            : BasicMap_getKeyByIndex(
                                 io_type.subTypesList.hMap: 1));                            //RADDAT
            x = x - 1;                                                                      //RADDAT
 E01     enddo;                                                                             //RADDAT
                                                                                            //RADDAT
         p_assert(BasicMap_getNumE(io_type.subTypesList.hMap) = 0
                  : 'Map must not contain any entries when sub types +
                     have been deleted');                                                   //RADDAT
                                                                                            //RADDAT
         return;                                                                            //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_deleteSubTypes...                                                              RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Type helper:                                                                         RADDAT
     *  Returns cTrue if a type is NULL.                                                     RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_isNull...                                                                      RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_isNull...                                                                      RADDAT
     D                 PI              N                                                      RADDAT
     D  i_type                             const  likeds(wsdl_type_t )                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
 B01     if (i_type = TypeDef_null());                                                      //RADDAT
            return cTrue;                                                                   //RADDAT
 X01     else;                                                                              //RADDAT
            return cFalse;                                                                  //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_isNull...                                                                      RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Type helper:                                                                         RADDAT
     *  Returns a NULL type.                                                                 RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_null...                                                                        RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_null...                                                                        RADDAT
     D                 PI                         likeds(wsdl_type_t )                        RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D type            DS                  likeds(wsdl_type_t ) inz                           RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
         clear type;                                                                        //RADDAT
                                                                                            //RADDAT
         return type;                                                                       //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_null...                                                                        RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Type helper:                                                                         RADDAT
     *  Returns a new and unique level-1 type name based on a given name                     RADDAT
     *  and suffix.                                                                          RADDAT
     *=====================================================================*                 RADDAT
    P TypeDef_produceName...                                                                 RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D TypeDef_produceName...                                                                 RADDAT
     D                 PI                         likeds(wsdl_qName_t)                        RADDAT
     D  i_baseQName                        const  likeds(wsdl_qName_t)                        RADDAT
     D  i_suffix                     32A   const  varying                                     RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D qName           DS                  likeds(wsdl_qName_t) inz                           RADDAT
     *                                                                                       RADDAT
     *  Helper fields                                                                        RADDAT
     D x               S             10I 0 inz                                                RADDAT
     D i               S             10I 0 inz                                                RADDAT
     D isUnique        S               N   inz(cTrue)                                         RADDAT
     D type            DS                  likeds(wsdl_type_t ) inz                           RADDAT
     *                                                                                       RADDAT
     *  Global types list
     D hGlobalTypes    S                   like(BasicMap_handle_t) inz
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT

         hGlobalTypes = Controller_getGlobalTypesList();
                                                                                            //RADDAT
 B01     dou isUnique;                                                                      //RADDAT
            isUnique = cTrue;                                                               //RADDAT
                                                                                            //RADDAT
            qName = i_baseQName;                                                            //RADDAT
            qName.lName = qName.lName + i_suffix;                                           //RADDAT
 B02        if (x > 0);                                                                     //RADDAT
               qName.lName = qName.lName + %char(x);                                        //RADDAT
 E02        endif;                                                                          //RADDAT
                                                                                            //RADDAT
 B02        for i = 1 to BasicMap_getNumE(hGlobalTypes);
               BasicMap_getValueByIndex(hGlobalTypes
                                        : i
                                        : %addr(type)
                                        : %size(type));                                     //RADDAT
                                                                                            //RADDAT
 B03           if (QName_getLName(qName) =
                   QName_getLName(TypeDef_getQName(type)));                                 //RADDAT
                  isUnique = cFalse;                                                        //RADDAT
                  leave;                                                                    //RADDAT
 E03           endif;                                                                       //RADDAT
 B03           if (f_ucase(QName_getLName(qName)) =
                   f_ucase(QName_getLName(TypeDef_getQName(type))));                        //RADDAT
                  isUnique = cFalse;                                                        //RADDAT
                  leave;                                                                    //RADDAT
 E03           endif;                                                                       //RADDAT
                                                                                            //RADDAT
 E02        endfor;                                                                         //RADDAT
                                                                                            //RADDAT
 B02        if (not isUnique);                                                              //RADDAT
               x = x + 1;                                                                   //RADDAT
 E02        endif;                                                                          //RADDAT
 E01     enddo;                                                                             //RADDAT
                                                                                            //RADDAT
         return qName;                                                                      //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P TypeDef_produceName...                                                                 RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
   R *  *** private ***                                                                      RADDAT
     *  Initializes a type definition.                                                       RADDAT
     *=====================================================================*                 RADDAT
    P initializeTypeDef...                                                                   RADDAT
    P                 B                                                                      RADDAT
     *                                                                                       RADDAT
     D initializeTypeDef...                                                                   RADDAT
     D                 PI                         likeds(wsdl_type_t )                        RADDAT
     D  i_name                             const  like(wsdl_name_t   )                        RADDAT
     D  i_type                             const  like(wsdl_name_t   )                        RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D type            DS                  likeds(wsdl_type_t ) inz                           RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         initializeModule();                                                                //RADDAT
                                                                                            //RADDAT
         clear type;                                                                        //RADDAT
         type.isChoice       = cFalse;                                                      //RADDAT
         type.isUsed         = cFalse;                                                      //RADDAT
         type.isSequence     = cFalse;                                                      //RADDAT
         type.isQualified    = cFalse;                                                      //RADDAT
         type.arrayType      = cARRAY_NONE;                                                 //RADDAT
         type.arrayID        = 0;                                                           //RADDAT
         type.dim            = 0;                                                           //RADDAT
         type.qName          = QName_new(i_name);                                           //RADDAT
 B01     if (i_type = '');                                                                  //RADDAT
            type.qType = QName_null();                                                      //RADDAT
 X01     else;                                                                              //RADDAT
            type.qType = QName_new(i_type);                                                 //RADDAT
 E01     endif;                                                                             //RADDAT
         type.subTypesList.hMap     = BasicMap_null();                                      //RADDAT
         type.subTypesList.curKey   = '';                                                   //RADDAT
         type.subTypesList.isChoice = cFalse;                                               //RADDAT
                                                                                            //RADDAT
 B01     if (type.qType.lName = cTYPE_REFERENCE);                                           //RADDAT
            type.referencesType = cTrue;                                                    //RADDAT
 X01     else;                                                                              //RADDAT
            type.referencesType = cFalse;                                                   //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         return type;                                                                       //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P initializeTypeDef...                                                                   RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
   R *  *** private ***                                                                      RADDAT
     *  Returns a RPG callback procedure base name for a given type.                         RADDAT
     *=====================================================================*                 RADDAT
    P getProcName...                                                                         RADDAT
    P                 B                                                                      RADDAT
     *                                                                                       RADDAT
     D getProcName...                                                                         RADDAT
     D                 PI                         like(wsdl_name_t   )                        RADDAT
     D  i_type                             const  likeds(wsdl_type_t )                        RADDAT
     D  i_parent                           const  likeds(wsdl_type_t )                        RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D name            S                   like(wsdl_name_t ) inz                             RADDAT
     *                                                                                       RADDAT
     *  Helper fields                                                                        RADDAT
     D theType         DS                  likeds(wsdl_type_t ) inz                           RADDAT
     D qName           DS                  likeds(wsdl_qName_t) inz                           RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
 B01     if (TypeDef_isUserDefined(i_type));                                                //RADDAT
            theType = TypeDef_getFinalType(i_type);                                         //RADDAT
 X01     else;                                                                              //RADDAT
            theType = i_type;                                                               //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         qName = TypeDef_getQType(theType);                                                 //RADDAT
 B01     if (QName_isNull(qName));                                                          //RADDAT
            qName = TypeDef_getQName(theType);                                              //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
 B01     if (QName_getNSPrefix(qName) <> '');                                               //RADDAT
            name = QName_getNSPrefix(qName) + '_'+ QName_getLName(qName);                   //RADDAT
 X01     else;                                                                              //RADDAT
            name = QName_getLName(qName);                                                   //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
 B01     if (TypeDef_isNull(i_parent));                                                     //RADDAT
            return name;                                                                    //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         return name;                                                                       //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P getProcName...                                                                         RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Initializes this module.                                                             RADDAT
     *=====================================================================*                 RADDAT
    P initializeModule...                                                                    RADDAT
    P                 B                                                                      RADDAT
     *                                                                                       RADDAT
     D initializeModule...                                                                    RADDAT
     D                 PI                                                                     RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
 B01     if (g_isInit);                                                                     //RADDAT
            return;                                                                         //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         g_hLogger = Logger_getLogger(cLOGGER + cLOGGER_TYPES);                             //RADDAT
                                                                                            //RADDAT
         g_isInit = cTrue;                                                                  //RADDAT
                                                                                            //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P initializeModule...                                                                    RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
