     *=====================================================================*                 RADDAT
     *  WSDL2RPG: UnMarshaller/Marshaller Helper                           *                 RADDAT
     *=====================================================================*                 RADDAT
     *  Author  :  Thomas Raddatz                                          *                 RADDAT
     *  Date    :  15.05.2008                                              *                 RADDAT
     *  E-mail  :  thomas.raddatz@Tools400.de                              *                 RADDAT
     *  Homepage:  www.tools400.de                                         *                 RADDAT
     *=====================================================================*                 RADDAT
     *                                                                     *                 RADDAT
     *  This software is free software, you can redistribute it and/or     *                 RADDAT
     *  modify it under the terms of the GNU General Public License (GPL)  *                 RADDAT
     *  as published by the Free Software Foundation.                      *                 RADDAT
     *                                                                     *                 RADDAT
     *  See GNU General Public License for details.                        *                 RADDAT
     *          http://www.opensource.org                                  *                 RADDAT
     *          http://www.opensource.org/licenses/gpl-license.html        *                 RADDAT
     *                                                                     *                 RADDAT
     *=====================================================================*                 RADDAT
     *  History:                                                           *                 RADDAT
     *                                                                     *                 RADDAT
     *  Datum       Name          nderung                                 *                 RADDAT
     *  ----------  ------------  ---------------------------------------  *                 RADDAT
     *  03.09.2008  Th.Raddatz    Added Marshallers/UnMarshallers for      *                 RADDAT
     *                            'date', 'time',                          *                 RADDAT
     *                            'long', 'unsigned short', 'unsigned int' *                 RADDAT
     *                            'unsigned long', 'nonNegativeInteger',   *                 RADDAT
     *                            'nonPositiveInteger', 'negativeInteger', *                 RADDAT
     *                            'positiveInteger' data types.            *                 RADDAT
     *                                                                     *                 RADDAT
     *=====================================================================*                 RADDAT
     *   >>PRE-COMPILER<<                                                  *                 RADDAT
     *                                                                     *                 RADDAT
     *     >>CRTCMD<<  CRTRPGMOD   MODULE(&LI/&OB) +                       *                 RADDAT
     *                             SRCFILE(&SL/&SF) +                      *                 RADDAT
     *                             SRCMBR(&SM);                            *                 RADDAT
     *                                                                     *                 RADDAT
     *     >>COMPILE<<                                                     *                 RADDAT
     *       >>PARM<< TRUNCNBR(*NO);                                       *                 RADDAT
     *       >>PARM<< DBGVIEW(*LIST);                                      *                 RADDAT
     *       >>PARM<< TGTRLS(V5R3M0  );                                    *                 RADDAT
     *     >>END-COMPILE<<                                                 *                 RADDAT
     *                                                                     *                 RADDAT
     *     >>EXECUTE<<                                                     *                 RADDAT
     *                                                                     *                 RADDAT
     *   >>END-PRE-COMPILER<<                                              *                 RADDAT
     *=====================================================================*                 RADDAT
 CPY H NOMAIN                                                                                 RADDAT
      /DEFINE NO_DECEDIT                                                                      RADDAT
CPY  /COPY QWSDL2RPG,H_SPEC                                                                 RADDAT
     H DECEDIT('0.')                                                                          RADDAT
      /UNDEFINE NO_DECEDIT                                                                    RADDAT
     *=====================================================================*                 RADDAT
     *                                                                                       RADDAT
     * ------------------------------------                                                  RADDAT
     *  Constants                                                                            RADDAT
     * ------------------------------------                                                  RADDAT
     *                                                                                       RADDAT
     * ------------------------------------                                                  RADDAT
     *  Type Definitions                                                                     RADDAT
     * ------------------------------------                                                  RADDAT
CPY  /COPY QWSDL2RPG,TYPES                                                                  RADDAT
     *                                                                                       RADDAT
     * ------------------------------------                                                  RADDAT
     *  Exported prototypes                                                                  RADDAT
     * ------------------------------------                                                  RADDAT
CPY  /COPY QWSDL2RPG,PWSDL2R92                                                              RADDAT
     *                                                                                       RADDAT
     * ------------------------------------                                                  RADDAT
     *  Imported prototypes                                                                  RADDAT
     * ------------------------------------                                                  RADDAT
CPY  /COPY QWSDL2RPG,CLIB                        C Runtime Library                          RADDAT
     *                                                                                       RADDAT
CPY  /COPY QWSDL2RPG,PWSDL2R01                   WSDL2RPG: Main / Controller                RADDAT
CPY  /COPY QWSDL2RPG,PWSDL2R90                   WSDL2RPG: Application Message              RADDAT
CPY  /COPY QWSDL2RPG,PWSDL2R95                   WSDL2RPG: RpgType                          RADDAT
     *                                                                                       RADDAT
     * ------------------------------------                                                  RADDAT
     *  Internal prototypes                                                                  RADDAT
     * ------------------------------------                                                  RADDAT
     *                                                                                       RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     D getRpgAnyType...                                                                       RADDAT
     D                 PR                         likeds(wsdl_rpgType_t )                     RADDAT
     D                                            extproc('+                                  RADDAT
     D                                            getRpgAnyType+                              RADDAT
     D                                            ')                                          RADDAT
     *                                                                                       RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     D getRpgAny...                                                                           RADDAT
     D                 PR                         likeds(wsdl_rpgType_t )                     RADDAT
     D                                            extproc('+                                  RADDAT
     D                                            getRpgAny+                                  RADDAT
     D                                            ')                                          RADDAT
     *                                                                                       RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     D getRpgSchema...                                                                        RADDAT
     D                 PR                         likeds(wsdl_rpgType_t )                     RADDAT
     D                                            extproc('+                                  RADDAT
     D                                            getRpgSchema+                               RADDAT
     D                                            ')                                          RADDAT
     *                                                                                       RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     D getRpgString...                                                                        RADDAT
     D                 PR                         likeds(wsdl_rpgType_t )                     RADDAT
     D                                            extproc('+                                  RADDAT
     D                                            getRpgString+                               RADDAT
     D                                            ')                                          RADDAT
     *                                                                                       RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     D getRpgBoolean...                                                                       RADDAT
     D                 PR                         likeds(wsdl_rpgType_t )                     RADDAT
     D                                            extproc('+                                  RADDAT
     D                                            getRpgBoolean+                              RADDAT
     D                                            ')                                          RADDAT
     *                                                                                       RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     D getRpgDecimal...                                                                       RADDAT
     D                 PR                         likeds(wsdl_rpgType_t )                     RADDAT
     D                                            extproc('+                                  RADDAT
     D                                            getRpgDecimal+                              RADDAT
     D                                            ')                                          RADDAT
     *                                                                                       RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     D getRpgFloat...                                                                         RADDAT
     D                 PR                         likeds(wsdl_rpgType_t )                     RADDAT
     D                                            extproc('+                                  RADDAT
     D                                            getRpgFloat+                                RADDAT
     D                                            ')                                          RADDAT
     *                                                                                       RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     D getRpgDouble...                                                                        RADDAT
     D                 PR                         likeds(wsdl_rpgType_t )                     RADDAT
     D                                            extproc('+                                  RADDAT
     D                                            getRpgDouble+                               RADDAT
     D                                            ')                                          RADDAT
     *                                                                                       RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     D getRpgShort...                                                                         RADDAT
     D                 PR                         likeds(wsdl_rpgType_t )                     RADDAT
     D                                            extproc('+                                  RADDAT
     D                                            getRpgShort+                                RADDAT
     D                                            ')                                          RADDAT
     *                                                                                       RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     D getRpgInteger...                                                                       RADDAT
     D                 PR                         likeds(wsdl_rpgType_t )                     RADDAT
     D                                            extproc('+                                  RADDAT
     D                                            getRpgInteger+                              RADDAT
     D                                            ')                                          RADDAT
     *                                                                                       RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     D getRpgLong...                                                                          RADDAT
     D                 PR                         likeds(wsdl_rpgType_t )                     RADDAT
     D                                            extproc('+                                  RADDAT
     D                                            getRpgLong+                                 RADDAT
     D                                            ')                                          RADDAT
     *                                                                                       RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     D getRpgUShort...                                                                        RADDAT
     D                 PR                         likeds(wsdl_rpgType_t )                     RADDAT
     D                                            extproc('+                                  RADDAT
     D                                            getRpgUShort+                               RADDAT
     D                                            ')                                          RADDAT
     *                                                                                       RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     D getRpgUInteger...                                                                      RADDAT
     D                 PR                         likeds(wsdl_rpgType_t )                     RADDAT
     D                                            extproc('+                                  RADDAT
     D                                            getRpgUInteger+                             RADDAT
     D                                            ')                                          RADDAT
     *                                                                                       RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     D getRpgULong...                                                                         RADDAT
     D                 PR                         likeds(wsdl_rpgType_t )                     RADDAT
     D                                            extproc('+                                  RADDAT
     D                                            getRpgULong+                                RADDAT
     D                                            ')                                          RADDAT
     *                                                                                       RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     D getRpgNonNegInt...                                                                     RADDAT
     D                 PR                         likeds(wsdl_rpgType_t )                     RADDAT
     D                                            extproc('+                                  RADDAT
     D                                            getRpgNonNegInt+                            RADDAT
     D                                            ')                                          RADDAT
     *                                                                                       RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     D getRpgNonPosInt...                                                                     RADDAT
     D                 PR                         likeds(wsdl_rpgType_t )                     RADDAT
     D                                            extproc('+                                  RADDAT
     D                                            getRpgNonPosInt+                            RADDAT
     D                                            ')                                          RADDAT
     *                                                                                       RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     D getRpgNegInt...                                                                        RADDAT
     D                 PR                         likeds(wsdl_rpgType_t )                     RADDAT
     D                                            extproc('+                                  RADDAT
     D                                            getRpgNegInt+                               RADDAT
     D                                            ')                                          RADDAT
     *                                                                                       RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     D getRpgPosInt...                                                                        RADDAT
     D                 PR                         likeds(wsdl_rpgType_t )                     RADDAT
     D                                            extproc('+                                  RADDAT
     D                                            getRpgPosInt+                               RADDAT
     D                                            ')                                          RADDAT
     *                                                                                       RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     D getRpgDateTime...                                                                      RADDAT
     D                 PR                         likeds(wsdl_rpgType_t )                     RADDAT
     D                                            extproc('+                                  RADDAT
     D                                            getRpgDateTime+                             RADDAT
     D                                            ')                                          RADDAT
     *                                                                                       RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     D getRpgDate...                                                                          RADDAT
     D                 PR                         likeds(wsdl_rpgType_t )                     RADDAT
     D                                            extproc('+                                  RADDAT
     D                                            getRpgDate+                                 RADDAT
     D                                            ')                                          RADDAT
     *                                                                                       RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     D getRpgTime...                                                                          RADDAT
     D                 PR                         likeds(wsdl_rpgType_t )                     RADDAT
     D                                            extproc('+                                  RADDAT
     D                                            getRpgTime+                                 RADDAT
     D                                            ')                                          RADDAT
     *                                                                                       RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     D getRpgBase64Binary...                                                                  RADDAT
     D                 PR                         likeds(wsdl_rpgType_t )                     RADDAT
     D                                            extproc('+                                  RADDAT
     D                                            getRpgBase64Binary+                         RADDAT
     D                                            ')                                          RADDAT
     *                                                                                       RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     D getRpgLanguage...                                                                      RADDAT
     D                 PR                         likeds(wsdl_rpgType_t )                     RADDAT
     D                                            extproc('+                                  RADDAT
     D                                            getRpgLanguage+                             RADDAT
     D                                            ')                                          RADDAT
     *                                                                                       RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     D getRpgToken...                                                                         RADDAT
     D                 PR                         likeds(wsdl_rpgType_t )                     RADDAT
     D                                            extproc('+                                  RADDAT
     D                                            getRpgToken+                                RADDAT
     D                                            ')                                          RADDAT
     *                                                                                       RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     D getRpgAnyURI...                                                                        RADDAT
     D                 PR                         likeds(wsdl_rpgType_t )                     RADDAT
     D                                            extproc('+                                  RADDAT
     D                                            getRpgAnyURI+                               RADDAT
     D                                            ')                                          RADDAT
     *                                                                                       RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     D getRpgDuration...                                                                      RADDAT
     D                 PR                         likeds(wsdl_rpgType_t )                     RADDAT
     D                                            extproc('+                                  RADDAT
     D                                            getRpgDuration+                             RADDAT
     D                                            ')                                          RADDAT
     *                                                                                       RADDAT
     * ------------------------------------                                                  RADDAT
     *  Global fields & constants                                                            RADDAT
     * ------------------------------------                                                  RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Returns the RPG type for a given primitive type.                                     RADDAT
     *=====================================================================*                 RADDAT
    P UnMarshaller_getRpgType...                                                             RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D UnMarshaller_getRpgType...                                                             RADDAT
     D                 PI                         likeds(wsdl_rpgType_t  )                    RADDAT
     D  i_primitive                        const  likeds(wsdl_type_t     )                    RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D rpgType         DS                  likeds(wsdl_rpgType_t  ) inz                       RADDAT
     *                                                                                       RADDAT
     *  Helper fields                                                                        RADDAT
     D lName           S                   like(wsdl_name_t ) inz                             RADDAT
     D msg             DS                  likeds(msg_t ) inz                                 RADDAT
     *                                                                                       RADDAT
     *  Messages                                                                             RADDAT
CPY  /COPY QWSDL2RPG,USR5002                     Unknown XML data type.                     RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE

         lName = f_lcase(i_primitive.qType.lName);
                                                                                            //RADDAT
         //Unmarshall ...                                                                  //RADDAT
 B01     select;                                                                            //RADDAT
         //... java.lang.String              (xsd:anyType)                                 //RADDAT
         when (lName = f_lcase(cXSD_ANYTYPE));
            rpgType = getRpgAnyType();                                                      //RADDAT
                                                                                            //RADDAT
         //... java.lang.String              (xsd:any)                                     //RADDAT
         when (lName = f_lcase(cXSD_ANY));
            rpgType = getRpgAny();                                                          //RADDAT
                                                                                            //RADDAT
         //... java.lang.String              (xsd:schema)                                  //RADDAT
         when (lName = f_lcase(cXSD_SCHEMA));
            rpgType = getRpgSchema();                                                       //RADDAT
                                                                                            //RADDAT
         //... java.lang.String              (xsd:string)                                  //RADDAT
         when (lName = f_lcase(cXSD_STRING));
            rpgType = getRpgString();                                                       //RADDAT
                                                                                            //RADDAT
         //... java.lang.Boolean / boolean                                                 //RADDAT
         when (lName = f_lcase(cXSD_BOOLEAN));
            rpgType = getRpgBoolean();                                                      //RADDAT
                                                                                            //RADDAT
         //... java.math.BigDecimal          (xsd:decimal)                                 //RADDAT
         when (lName = f_lcase(cXSD_DECIMAL));
            rpgType = getRpgDecimal();                                                      //RADDAT
                                                                                            //RADDAT
         //... java.lang.Float               (xsd:float)                                   //RADDAT
         when (lName = f_lcase(cXSD_FLOAT));
            rpgType = getRpgFloat();                                                        //RADDAT
                                                                                            //RADDAT
         //... java.lang.Double              (xsd:double)                                  //RADDAT
         when (lName = f_lcase(cXSD_DOUBLE));
            rpgType = getRpgDouble();                                                       //RADDAT
                                                                                            //RADDAT
         //... java.lang.short   / short     (xsd:short)                                   //RADDAT
         when (lName = f_lcase(cXSD_SHORT));
            rpgType = getRpgShort();                                                        //RADDAT
                                                                                            //RADDAT
         //... java.lang.Integer / int       (xsd:int)                                     //RADDAT
         when (lName = f_lcase(cXSD_INT));
            rpgType = getRpgInteger();                                                      //RADDAT
                                                                                            //RADDAT
         //... java.lang.Long    / long      (xsd:long)                                    //RADDAT
         when (lName = f_lcase(cXSD_LONG));
            rpgType = getRpgLong();                                                         //RADDAT
                                                                                            //RADDAT
         //... java.lang.UnsignedShort       (xsd:unsignedShort)                           //RADDAT
         when (lName = f_lcase(cXSD_USHORT));
            rpgType = getRpgUShort();                                                       //RADDAT
                                                                                            //RADDAT
         //... java.lang.UnsignedInteger     (xsd:unsignedInt)                             //RADDAT
         when (lName = f_lcase(cXSD_UINT));
            rpgType = getRpgUInteger();                                                     //RADDAT
                                                                                            //RADDAT
         //... java.lang.UnsignedLong        (xsd:unsignedLong)                            //RADDAT
         when (lName = f_lcase(cXSD_ULONG));
            rpgType = getRpgULong();                                                        //RADDAT
                                                                                            //RADDAT
         //... java.lang.Integer / int       (xsd:nonNegativeInteger)                      //RADDAT
         when (lName = f_lcase(cXSD_NON_NEG_INT));
            rpgType = getRpgNonNegInt();                                                    //RADDAT
                                                                                            //RADDAT
         //... java.lang.Integer / int       (xsd:nonPositiveInteger)                      //RADDAT
         when (lName = f_lcase(cXSD_NON_POS_INT));
            rpgType = getRpgNonPosInt();                                                    //RADDAT
                                                                                            //RADDAT
         //... java.lang.Integer / int       (xsd:negativeInteger)                         //RADDAT
         when (lName = f_lcase(cXSD_NEG_INT));
            rpgType = getRpgNegInt();                                                       //RADDAT
                                                                                            //RADDAT
         //... java.lang.Integer / int       (xsd:positiveInteger)                         //RADDAT
         when (lName = f_lcase(cXSD_POS_INT));
            rpgType = getRpgPosInt();                                                       //RADDAT
                                                                                            //RADDAT
         //... java.util.Date                (xsd:dateTime)                                //RADDAT
         when (lName = f_lcase(cXSD_DATETIME));
            rpgType = getRpgDateTime();                                                     //RADDAT
                                                                                            //RADDAT
         //...                               (xsd:date    )                                //RADDAT
         when (lName = f_lcase(cXSD_DATE));
            rpgType = getRpgDate();                                                         //RADDAT
                                                                                            //RADDAT
         //...                               (xsd:time    )                                //RADDAT
         when (lName = f_lcase(cXSD_TIME));
            rpgType = getRpgTime();                                                         //RADDAT
                                                                                            //RADDAT
         //...                               (xsd:base64Binary)                            //RADDAT
         when (lName = f_lcase(cXSD_BASE64BINARY));
            rpgType = getRpgBase64Binary();                                                 //RADDAT
                                                                                            //RADDAT
         //...                               (xsd:language)                                //RADDAT
         when (lName = f_lcase(cXSD_LANGUAGE));
            rpgType = getRpgLanguage();                                                     //RADDAT
                                                                                            //RADDAT
         //...                               (xsd:token)                                   //RADDAT
         when (lName = f_lcase(cXSD_TOKEN));
            rpgType = getRpgToken();                                                        //RADDAT
                                                                                            //RADDAT
         //...                               (xsd:anyURI)                                  //RADDAT
         when (lName = f_lcase(cXSD_ANYURI));
            rpgType = getRpgAnyURI();                                                       //RADDAT
                                                                                            //RADDAT
         //...                               (xsd:duration)                                //RADDAT
         when (lName = f_lcase(cXSD_DURATION));
            rpgType = getRpgDuration();                                                     //RADDAT
                                                                                            //RADDAT
 X01     other;                                                                             //RADDAT
            clear USR5002;                                                                  //RADDAT
            USR50021 = i_primitive.qType.lName;                                             //RADDAT
            AppMsg_sendToCmdLine(AppMsg_newError('USR5002': USR5002));                      //RADDAT
            Controller_setError();                                                          //RADDAT
 E01     endsl;                                                                             //RADDAT
                                                                                            //RADDAT
         return rpgType;                                                                    //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P UnMarshaller_getRpgType...                                                             RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Returns the procedure used to unmarshall a XML value.                                RADDAT
     *=====================================================================*                 RADDAT
    P UnMarshaller_getUnMarshallerProcName...                                                RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D UnMarshaller_getUnMarshallerProcName...                                                RADDAT
     D                 PI          4096A          varying                                     RADDAT
     D  i_primitive                        const  likeds(wsdl_type_t     )                    RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D procName        S           4096A   varying inz                                        RADDAT
     *                                                                                       RADDAT
     *  Helper fields                                                                        RADDAT
     D primitiveType   S                   like(wsdl_qName_t.lName)                           RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         primitiveType = i_primitive.qType.lName;                                           //RADDAT
         %subst(primitiveType: 1: 1) = f_ucase(%subst(primitiveType: 1: 1));                //RADDAT
                                                                                            //RADDAT
         procName = 'UnMarshaller_to' + primitiveType;                                      //RADDAT
                                                                                            //RADDAT
         return procName;                                                                   //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P UnMarshaller_getUnMarshallerProcName...                                                RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
     *  Returns the procedure used to marshall a RPG value.                                  RADDAT
     *=====================================================================*                 RADDAT
    P Marshaller_getMarshallerProcName...                                                    RADDAT
    P                 B                   export                                             RADDAT
     *                                                                                       RADDAT
     D Marshaller_getMarshallerProcName...                                                    RADDAT
     D                 PI          4096A          varying                                     RADDAT
     D  i_primitive                        const  likeds(wsdl_type_t     )                    RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D procName        S           4096A   varying inz                                        RADDAT
     *                                                                                       RADDAT
     *  Helper fields                                                                        RADDAT
     D primitiveType   S                   like(wsdl_qName_t.lName)                           RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         primitiveType = i_primitive.qType.lName;                                           //RADDAT
         %subst(primitiveType: 1: 1) = f_ucase(%subst(primitiveType: 1: 1));                //RADDAT
                                                                                            //RADDAT
         procName = 'Marshaller_to' + primitiveType;                                        //RADDAT
                                                                                            //RADDAT
         return procName;                                                                   //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P Marshaller_getMarshallerProcName...                                                    RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
   R *  *** private ***                                                                      RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     *=====================================================================*                 RADDAT
    P getRpgAnyType...                                                                       RADDAT
    P                 B                                                                      RADDAT
     *                                                                                       RADDAT
     D getRpgAnyType...                                                                       RADDAT
     D                 PI                         likeds(wsdl_rpgType_t )                     RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D rpgType         DS                  likeds(wsdl_rpgType_t ) inz                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         rpgType = getRpgString();                                                          //RADDAT
                                                                                            //RADDAT
         return rpgType;                                                                    //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P getRpgAnyType...                                                                       RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
   R *  *** private ***                                                                      RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     *=====================================================================*                 RADDAT
    P getRpgAny...                                                                           RADDAT
    P                 B                                                                      RADDAT
     *                                                                                       RADDAT
     D getRpgAny...                                                                           RADDAT
     D                 PI                         likeds(wsdl_rpgType_t )                     RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D rpgType         DS                  likeds(wsdl_rpgType_t ) inz                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         rpgType = getRpgString();                                                          //RADDAT
         rpgType.length = 16384;                                                            //RADDAT
                                                                                            //RADDAT
         return rpgType;                                                                    //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P getRpgAny...                                                                           RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
   R *  *** private ***                                                                      RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     *=====================================================================*                 RADDAT
    P getRpgSchema...                                                                        RADDAT
    P                 B                                                                      RADDAT
     *                                                                                       RADDAT
     D getRpgSchema...                                                                        RADDAT
     D                 PI                         likeds(wsdl_rpgType_t )                     RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D rpgType         DS                  likeds(wsdl_rpgType_t ) inz                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         rpgType = getRpgString();                                                          //RADDAT
         rpgType.length = 4096;                                                             //RADDAT
                                                                                            //RADDAT
         return rpgType;                                                                    //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P getRpgSchema...                                                                        RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
   R *  *** private ***                                                                      RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     *=====================================================================*                 RADDAT
    P getRpgString...                                                                        RADDAT
    P                 B                                                                      RADDAT
     *                                                                                       RADDAT
     D getRpgString...                                                                        RADDAT
     D                 PI                         likeds(wsdl_rpgType_t )                     RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D rpgType         DS                  likeds(wsdl_rpgType_t ) inz                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         rpgType = RpgType_new();                                                           //RADDAT
                                                                                            //RADDAT
         rpgType.length   = Controller_getDefaultStringLength();                            //RADDAT
         rpgType.dataType = 'A';                                                            //RADDAT
         rpgType.keyword  = 'varying';                                                      //RADDAT
                                                                                            //RADDAT
         return rpgType;                                                                    //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P getRpgString...                                                                        RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
   R *  *** private ***                                                                      RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     *=====================================================================*                 RADDAT
    P getRpgBoolean...                                                                       RADDAT
    P                 B                                                                      RADDAT
     *                                                                                       RADDAT
     D getRpgBoolean...                                                                       RADDAT
     D                 PI                         likeds(wsdl_rpgType_t )                     RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D rpgType         DS                  likeds(wsdl_rpgType_t ) inz                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         rpgType = RpgType_new();                                                           //RADDAT
                                                                                            //RADDAT
         rpgType.dataType = 'N';                                                            //RADDAT
                                                                                            //RADDAT
         return rpgType;                                                                    //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P getRpgBoolean...                                                                       RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
   R *  *** private ***                                                                      RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     *=====================================================================*                 RADDAT
    P getRpgDecimal...                                                                       RADDAT
    P                 B                                                                      RADDAT
     *                                                                                       RADDAT
     D getRpgDecimal...                                                                       RADDAT
     D                 PI                         likeds(wsdl_rpgType_t )                     RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D rpgType         DS                  likeds(wsdl_rpgType_t ) inz                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         rpgType = RpgType_new();                                                           //RADDAT
                                                                                            //RADDAT
         rpgType.length   = cDECIMAL_LEN;                                                   //RADDAT
         rpgType.dataType = cDECIMAL_TYPE;                                                  //RADDAT
         rpgType.decPos   = cDECIMAL_DECPOS;                                                //RADDAT
                                                                                            //RADDAT
         return rpgType;                                                                    //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P getRpgDecimal...                                                                       RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
   R *  *** private ***                                                                      RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     *=====================================================================*                 RADDAT
    P getRpgFloat...                                                                         RADDAT
    P                 B                                                                      RADDAT
     *                                                                                       RADDAT
     D getRpgFloat...                                                                         RADDAT
     D                 PI                         likeds(wsdl_rpgType_t )                     RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D rpgType         DS                  likeds(wsdl_rpgType_t ) inz                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         rpgType = RpgType_new();                                                           //RADDAT
                                                                                            //RADDAT
         rpgType.length   = cFLOAT_LEN;                                                     //RADDAT
         rpgType.dataType = cFLOAT_TYPE;                                                    //RADDAT
         rpgType.decPos   = cFLOAT_DECPOS;                                                  //RADDAT
                                                                                            //RADDAT
         return rpgType;                                                                    //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P getRpgFloat...                                                                         RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
   R *  *** private ***                                                                      RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     *=====================================================================*                 RADDAT
    P getRpgDouble...                                                                        RADDAT
    P                 B                                                                      RADDAT
     *                                                                                       RADDAT
     D getRpgDouble...                                                                        RADDAT
     D                 PI                         likeds(wsdl_rpgType_t )                     RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D rpgType         DS                  likeds(wsdl_rpgType_t ) inz                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         rpgType = RpgType_new();                                                           //RADDAT
                                                                                            //RADDAT
         rpgType.length   = cDOUBLE_LEN;                                                    //RADDAT
         rpgType.dataType = cDOUBLE_TYPE;                                                   //RADDAT
         rpgType.decPos   = cDOUBLE_DECPOS;                                                 //RADDAT
                                                                                            //RADDAT
         return rpgType;                                                                    //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P getRpgDouble...                                                                        RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
   R *  *** private ***                                                                      RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     *=====================================================================*                 RADDAT
    P getRpgShort...                                                                         RADDAT
    P                 B                                                                      RADDAT
     *                                                                                       RADDAT
     D getRpgShort...                                                                         RADDAT
     D                 PI                         likeds(wsdl_rpgType_t )                     RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D rpgType         DS                  likeds(wsdl_rpgType_t ) inz                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         rpgType = RpgType_new();                                                           //RADDAT
                                                                                            //RADDAT
         rpgType.length   = cSHORT_LEN;                                                     //RADDAT
         rpgType.dataType = cSHORT_TYPE;                                                    //RADDAT
         rpgType.decPos   = cSHORT_DECPOS;                                                  //RADDAT
                                                                                            //RADDAT
         return rpgType;                                                                    //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P getRpgShort...                                                                         RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
   R *  *** private ***                                                                      RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     *=====================================================================*                 RADDAT
    P getRpgInteger...                                                                       RADDAT
    P                 B                                                                      RADDAT
     *                                                                                       RADDAT
     D getRpgInteger...                                                                       RADDAT
     D                 PI                         likeds(wsdl_rpgType_t )                     RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D rpgType         DS                  likeds(wsdl_rpgType_t ) inz                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         rpgType = RpgType_new();                                                           //RADDAT
                                                                                            //RADDAT
         rpgType.length   = cINTEGER_LEN;                                                   //RADDAT
         rpgType.dataType = cINTEGER_TYPE;                                                  //RADDAT
         rpgType.decPos   = cINTEGER_DECPOS;                                                //RADDAT
                                                                                            //RADDAT
         return rpgType;                                                                    //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P getRpgInteger...                                                                       RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
   R *  *** private ***                                                                      RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     *=====================================================================*                 RADDAT
    P getRpgLong...                                                                          RADDAT
    P                 B                                                                      RADDAT
     *                                                                                       RADDAT
     D getRpgLong...                                                                          RADDAT
     D                 PI                         likeds(wsdl_rpgType_t )                     RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D rpgType         DS                  likeds(wsdl_rpgType_t ) inz                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         rpgType = RpgType_new();                                                           //RADDAT
                                                                                            //RADDAT
         rpgType.length   = cLONG_LEN;                                                      //RADDAT
         rpgType.dataType = cLONG_TYPE;                                                     //RADDAT
         rpgType.decPos   = cLONG_DECPOS;                                                   //RADDAT
                                                                                            //RADDAT
         return rpgType;                                                                    //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P getRpgLong...                                                                          RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
   R *  *** private ***                                                                      RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     *=====================================================================*                 RADDAT
    P getRpgUShort...                                                                        RADDAT
    P                 B                                                                      RADDAT
     *                                                                                       RADDAT
     D getRpgUShort...                                                                        RADDAT
     D                 PI                         likeds(wsdl_rpgType_t )                     RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D rpgType         DS                  likeds(wsdl_rpgType_t ) inz                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         rpgType = RpgType_new();                                                           //RADDAT
                                                                                            //RADDAT
         rpgType.length   = cUSHORT_LEN;                                                    //RADDAT
         rpgType.dataType = cUSHORT_TYPE;                                                   //RADDAT
         rpgType.decPos   = cUSHORT_DECPOS;                                                 //RADDAT
                                                                                            //RADDAT
         return rpgType;                                                                    //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P getRpgUShort...                                                                        RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
   R *  *** private ***                                                                      RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     *=====================================================================*                 RADDAT
    P getRpgUInteger...                                                                      RADDAT
    P                 B                                                                      RADDAT
     *                                                                                       RADDAT
     D getRpgUInteger...                                                                      RADDAT
     D                 PI                         likeds(wsdl_rpgType_t )                     RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D rpgType         DS                  likeds(wsdl_rpgType_t ) inz                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         rpgType = RpgType_new();                                                           //RADDAT
                                                                                            //RADDAT
         rpgType.length   = cUINTEGER_LEN;                                                  //RADDAT
         rpgType.dataType = cUINTEGER_TYPE;                                                 //RADDAT
         rpgType.decPos   = cUINTEGER_DECPOS;                                               //RADDAT
                                                                                            //RADDAT
         return rpgType;                                                                    //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P getRpgUInteger...                                                                      RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
   R *  *** private ***                                                                      RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     *=====================================================================*                 RADDAT
    P getRpgULong...                                                                         RADDAT
    P                 B                                                                      RADDAT
     *                                                                                       RADDAT
     D getRpgULong...                                                                         RADDAT
     D                 PI                         likeds(wsdl_rpgType_t )                     RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D rpgType         DS                  likeds(wsdl_rpgType_t ) inz                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         rpgType = RpgType_new();                                                           //RADDAT
                                                                                            //RADDAT
         rpgType.length   = cULONG_LEN;                                                     //RADDAT
         rpgType.dataType = cULONG_TYPE;                                                    //RADDAT
         rpgType.decPos   = cULONG_DECPOS;                                                  //RADDAT
                                                                                            //RADDAT
         return rpgType;                                                                    //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P getRpgULong...                                                                         RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
   R *  *** private ***                                                                      RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     *=====================================================================*                 RADDAT
    P getRpgNonNegInt...                                                                     RADDAT
    P                 B                                                                      RADDAT
     *                                                                                       RADDAT
     D getRpgNonNegInt...                                                                     RADDAT
     D                 PI                         likeds(wsdl_rpgType_t )                     RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D rpgType         DS                  likeds(wsdl_rpgType_t ) inz                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         rpgType = RpgType_new();                                                           //RADDAT
                                                                                            //RADDAT
         rpgType.length   = cNON_NEG_INT_LEN;                                               //RADDAT
         rpgType.dataType = cNON_NEG_INT_TYPE;                                              //RADDAT
         rpgType.decPos   = cNON_NEG_INT_DECPOS;                                            //RADDAT
                                                                                            //RADDAT
         return rpgType;                                                                    //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P getRpgNonNegInt...                                                                     RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
   R *  *** private ***                                                                      RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     *=====================================================================*                 RADDAT
    P getRpgNonPosInt...                                                                     RADDAT
    P                 B                                                                      RADDAT
     *                                                                                       RADDAT
     D getRpgNonPosInt...                                                                     RADDAT
     D                 PI                         likeds(wsdl_rpgType_t )                     RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D rpgType         DS                  likeds(wsdl_rpgType_t ) inz                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         rpgType = RpgType_new();                                                           //RADDAT
                                                                                            //RADDAT
         rpgType.length   = cNON_POS_INT_LEN;                                               //RADDAT
         rpgType.dataType = cNON_POS_INT_TYPE;                                              //RADDAT
         rpgType.decPos   = cNON_POS_INT_DECPOS;                                            //RADDAT
                                                                                            //RADDAT
         return rpgType;                                                                    //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P getRpgNonPosInt...                                                                     RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
   R *  *** private ***                                                                      RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     *=====================================================================*                 RADDAT
    P getRpgNegInt...                                                                        RADDAT
    P                 B                                                                      RADDAT
     *                                                                                       RADDAT
     D getRpgNegInt...                                                                        RADDAT
     D                 PI                         likeds(wsdl_rpgType_t )                     RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D rpgType         DS                  likeds(wsdl_rpgType_t ) inz                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         rpgType = RpgType_new();                                                           //RADDAT
                                                                                            //RADDAT
         rpgType.length   = cNEG_INT_LEN;                                                   //RADDAT
         rpgType.dataType = cNEG_INT_TYPE;                                                  //RADDAT
         rpgType.decPos   = cNEG_INT_DECPOS;                                                //RADDAT
                                                                                            //RADDAT
         return rpgType;                                                                    //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P getRpgNegInt...                                                                        RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
   R *  *** private ***                                                                      RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     *=====================================================================*                 RADDAT
    P getRpgPosInt...                                                                        RADDAT
    P                 B                                                                      RADDAT
     *                                                                                       RADDAT
     D getRpgPosInt...                                                                        RADDAT
     D                 PI                         likeds(wsdl_rpgType_t )                     RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D rpgType         DS                  likeds(wsdl_rpgType_t ) inz                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         rpgType = RpgType_new();                                                           //RADDAT
                                                                                            //RADDAT
         rpgType.length   = cPOS_INT_LEN;                                                   //RADDAT
         rpgType.dataType = cPOS_INT_TYPE;                                                  //RADDAT
         rpgType.decPos   = cPOS_INT_DECPOS;                                                //RADDAT
                                                                                            //RADDAT
         return rpgType;                                                                    //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P getRpgPosInt...                                                                        RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
   R *  *** private ***                                                                      RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     *=====================================================================*                 RADDAT
    P getRpgDateTime...                                                                      RADDAT
    P                 B                                                                      RADDAT
     *                                                                                       RADDAT
     D getRpgDateTime...                                                                      RADDAT
     D                 PI                         likeds(wsdl_rpgType_t )                     RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D rpgType         DS                  likeds(wsdl_rpgType_t ) inz                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         rpgType = RpgType_new();                                                           //RADDAT
                                                                                            //RADDAT
         rpgType.dataType = 'Z';                                                            //RADDAT
                                                                                            //RADDAT
         return rpgType;                                                                    //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P getRpgDateTime...                                                                      RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
   R *  *** private ***                                                                      RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     *=====================================================================*                 RADDAT
    P getRpgDate...                                                                          RADDAT
    P                 B                                                                      RADDAT
     *                                                                                       RADDAT
     D getRpgDate...                                                                          RADDAT
     D                 PI                         likeds(wsdl_rpgType_t )                     RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D rpgType         DS                  likeds(wsdl_rpgType_t ) inz                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         rpgType = RpgType_new();                                                           //RADDAT
                                                                                            //RADDAT
         rpgType.dataType = 'D';                                                            //RADDAT
                                                                                            //RADDAT
         return rpgType;                                                                    //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P getRpgDate...                                                                          RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
   R *  *** private ***                                                                      RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     *=====================================================================*                 RADDAT
    P getRpgTime...                                                                          RADDAT
    P                 B                                                                      RADDAT
     *                                                                                       RADDAT
     D getRpgTime...                                                                          RADDAT
     D                 PI                         likeds(wsdl_rpgType_t )                     RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D rpgType         DS                  likeds(wsdl_rpgType_t ) inz                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         rpgType = RpgType_new();                                                           //RADDAT
                                                                                            //RADDAT
         rpgType.dataType = 'T';                                                            //RADDAT
                                                                                            //RADDAT
         return rpgType;                                                                    //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P getRpgTime...                                                                          RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
   R *  *** private ***                                                                      RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     *=====================================================================*                 RADDAT
    P getRpgBase64Binary...                                                                  RADDAT
    P                 B                                                                      RADDAT
     *                                                                                       RADDAT
     D getRpgBase64Binary...                                                                  RADDAT
     D                 PI                         likeds(wsdl_rpgType_t )                     RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D rpgType         DS                  likeds(wsdl_rpgType_t ) inz                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         rpgType = getRpgString();                                                          //RADDAT
                                                                                            //RADDAT
         return rpgType;                                                                    //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P getRpgBase64Binary...                                                                  RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
   R *  *** private ***                                                                      RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     *=====================================================================*                 RADDAT
    P getRpgLanguage...                                                                      RADDAT
    P                 B                                                                      RADDAT
     *                                                                                       RADDAT
     D getRpgLanguage...                                                                      RADDAT
     D                 PI                         likeds(wsdl_rpgType_t )                     RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D rpgType         DS                  likeds(wsdl_rpgType_t ) inz                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         rpgType = getRpgString();                                                          //RADDAT
                                                                                            //RADDAT
         return rpgType;                                                                    //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P getRpgLanguage...                                                                      RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
   R *  *** private ***                                                                      RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     *=====================================================================*                 RADDAT
    P getRpgToken...                                                                         RADDAT
    P                 B                                                                      RADDAT
     *                                                                                       RADDAT
     D getRpgToken...                                                                         RADDAT
     D                 PI                         likeds(wsdl_rpgType_t )                     RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D rpgType         DS                  likeds(wsdl_rpgType_t ) inz                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         rpgType = getRpgString();                                                          //RADDAT
                                                                                            //RADDAT
         return rpgType;                                                                    //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P getRpgToken...                                                                         RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
   R *  *** private ***                                                                      RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     *=====================================================================*                 RADDAT
    P getRpgAnyURI...                                                                        RADDAT
    P                 B                                                                      RADDAT
     *                                                                                       RADDAT
     D getRpgAnyURI...                                                                        RADDAT
     D                 PI                         likeds(wsdl_rpgType_t )                     RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D rpgType         DS                  likeds(wsdl_rpgType_t ) inz                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         rpgType = getRpgString();                                                          //RADDAT
                                                                                            //RADDAT
         return rpgType;                                                                    //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P getRpgAnyURI...                                                                        RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
     *=====================================================================*                 RADDAT
   R *  *** private ***                                                                      RADDAT
     *  Converts a simple WSDL (schema) type to RPG.                                         RADDAT
     *=====================================================================*                 RADDAT
    P getRpgDuration...                                                                      RADDAT
    P                 B                                                                      RADDAT
     *                                                                                       RADDAT
     D getRpgDuration...                                                                      RADDAT
     D                 PI                         likeds(wsdl_rpgType_t )                     RADDAT
     *                                                                                       RADDAT
     *  Return value                                                                         RADDAT
     D rpgType         DS                  likeds(wsdl_rpgType_t ) inz                        RADDAT
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         rpgType = RpgType_new();                                                           //RADDAT
                                                                                            //RADDAT
         rpgType.dataType = 'DS';                                                           //RADDAT
         rpgType.keyword  = 'likeds(wsdl_duration_t)';                                      //RADDAT
                                                                                            //RADDAT
         return rpgType;                                                                    //RADDAT
                                                                                            //RADDAT
      /END-FREE
     *                                                                                       RADDAT
    P getRpgDuration...                                                                      RADDAT
    P                 E                                                                      RADDAT
     *                                                                                       RADDAT
